controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Etapa;
use app\models\Equipo;
use app\models\Puerto;



class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
 /*MOSTRAR ESTADÍSTICAS GENERALES*/
      public function actionGenerales()
    {
        $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() ,
          ]);
          /*Edad media de los ciclistas*/
          $media = Ciclista::find()->select ('AVG(edad) media') ->scalar();
          
                /*Etapa más larga*/
           $larga= Etapa::find() ->select('MAX(kms)' )-> scalar();
          $numero=Etapa::find() ->select('numetapa') ->where("kms = '$larga' ") ->scalar();
          
          
                /*Maillot más llevado*/
          $maillot=Lleva::find() ->groupby('código') ->count();
          $total=Lleva::find() -> select('código') ;
          
                /*Etapas circulares*/
          $circular=Etapa::find() -> select('count(*) total') -> where('salida = llegada') ->scalar();
          
          
                /*Ciclista que ha ganado más etapas*/
          
                /*Ciclista que ha ganado más puertos*/
          
                /*Ciclista que ha llevado más maillots*/
          
                /*Equipo con más ciclistas*/
          
                /*Puerto más alto*/
          $altura= Puerto::find() ->select('MAX(altura)' )-> scalar();
          $masalto=Puerto::find() ->select('nompuerto') ->where("altura = '$altura' ") ->scalar();
          
          
        return $this->render('general',[
            
          "resultado"=>$dataProvider,
            "media"=>round($media),
            'larga'=>$larga,
            'numero'=>$numero,
            'circular' => $circular,
            'altura'=>$altura,
            'masalto'=>$masalto,
            
          
        ]);
        
    }
    
     /*MOSTRAR ESTADÍSTICAS Ciclista*/
      public function actionCiclistas()
    {
          $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() ,
          ]);
          
          
        return $this->render('ciclistas',[
            "dataProvider" => $dataProvider,
            
            
        ]);
    }
    
     /*ESTADÍSTICAS Por cada ciclista*/
      public function actionEstadisticas($dorsal)
    {
           $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() -> where("dorsal= ' $dorsal' "),
          ]);
           
                /*Mostrar número de etapas  ganados*/
            $totales =  Etapa:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
            
            /*Mostrar número de puertos ganados*/
            $puertos = Puerto:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
            
                 /*Mostrar número de maillots ganados*/
             $maillots = Lleva:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
             
                  /*Mostrar el total de los premios ganados*/
            $query = new \yii\db\Query;
            $query  -> select('sum(premio) cantidad') ->from ('lleva')  ->join('INNER join', 'maillot', 'maillot.código=lleva.código') -> where("dorsal= ' $dorsal' ") -> groupby('dorsal');
            $premio = $query->scalar();
          	
                
              $premio  = ($premio  == null) ? 0 : $premio ;
       
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "totales" => $totales,
            "puertos" => $puertos,
            "maillots"=>$maillots,
            'premio'=>$premio,
   
        ]);
    }
    
 
    
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
}

views/site/_ciclistas.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
$titulo = 'Ciclistas de la vuelta España';
?>



    
    <div class="col-sm-12">
            <div class="card minimo">
              <div class="card-body">
                 <h5 class="card-title"><?=$model -> nombre?></h5>
                 <p class="card-text"><?="Dorsal del ciclista: ". $model -> dorsal?></p>
                 <?= Html::a('Ver más',['site/estadisticas', 'dorsal'=>$model -> dorsal, ], ['class' => 'btn btn-primary btn-block'] ) ?>
              </div>
            </div>
        </div>

     

views/site/_resultado.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
$titulo = 'Ciclistas de la vuelta España';
?>

<h1><?=$model -> nombre?></h1>
<p>  <?="Dorsal ". $model -> dorsal?>, <?=$model -> edad?> años, <?="Ciclista de ". $model -> nomequipo?></p>
        <div class="row">
            <div class="col-sm-6 col-md-3">
                      <div class="card minimo">
                        <div class="card-body">
                           <h3 class="card-title"> <?=$totales ?></h3>
                           <p class="card-text">Etapas Ganadas
                                   </p>
                        </div>
                      </div>
                  </div>
            <div class="col-sm-6 col-md-3">
                      <div class="card minimo">
                        <div class="card-body">
                           <h3 class="card-title"><?=$puertos ?></h3>
                           <p class="card-text">Puertos Ganados</p>

                        </div>
                      </div>
                  </div>
            
            <div class="col-sm-6 col-md-3">
                      <div class="card minimo">
                        <div class="card-body">
                           <h3 class="card-title"><?=$maillots?></h3>
                           <p class="card-text">Maillot Ganados</p>

                        </div>
                      </div>
                  </div>
            
       <div class="col-sm-6 col-md-3">
                      <div class="card minimo">
                        <div class="card-body">
                           <h3 class="card-title"><?=$premio?>€</h3>
                           <p class="card-text">Premio Ganado</p>

                        </div>
                      </div>
                  </div>
        </div>

views/site/about.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
        <div class="body-content">
        <h1><?= Html::encode($this->title) ?></h1>

        <p>
            Está página muestra la información y las estadísticas basandose en la vuelva ciclista España del año 1992.
        </p>
    </div>

 
</div>

views/site/ciclistas.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
$titulo = 'Ciclistas de la vuelta España';
?>


<div class="jumbotron ">
          <h1><?= $titulo?></h1>
                 
        <?=   ListView::widget([
            'dataProvider' => $dataProvider,
           'itemView' => '_ciclistas',
            'layout'=>"\n{items}\n\n\n{pager}",
            
        ]);
?>
          
      </div>
        
 

views/site/contact.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\ContactForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/general.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
$this->title = 'Vuelta ciclista';
?>
 <?=   ListView::widget([
            'dataProvider' => $resultado,

          'layout'=>"{items}",
          'viewParams' => ['media' => $media],

        ]);
?>

  <div id="carouselExampleCaptions" class="carousel slide" data-ride="carousel" data-interval="false">
  <ol class="carousel-indicators">
    <li data-target="#carouselExampleCaptions" data-slide-to="0" ></li>
    <li data-target="#carouselExampleCaptions" data-slide-to="1"></li>
    <li data-target="#carouselExampleCaptions" data-slide-to="2"></li>
  </ol>
  <div class="carousel-inner">
    <div class="carousel-item active">
     
      <div class="carousel-caption d-none d-md-block">
        <h5>Número de ciclistas por equipo</h5>
        <p>Gráfico del total de ciclistas que tiene cada equipo..</p>
      </div>
    </div>
    <div class="carousel-item">

      <div class="carousel-caption d-none d-md-block">
        <h5>Ciclistas y las etapas que han ganado.</h5>
        <p>Aquí iría el gráfico de las etapas ganadas por X ciclista.</p>
      </div>
    </div>
    <div class="carousel-item">

      <div class="carousel-caption d-none d-md-block">
        <h5>Ciclistas y los puertos que han ganado.</h5>
        <p>Aquí iría el gráfico de los puertos ganados por X ciclista.</p>
      </div>
    </div>
  </div>
  <button class="carousel-control-prev" type="button" data-target="#carouselExampleCaptions" data-slide="prev">
    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
    <span class="sr-only">Previous</span>
  </button>
  <button class="carousel-control-next" type="button" data-target="#carouselExampleCaptions" data-slide="next">
    <span class="carousel-control-next-icon" aria-hidden="true"></span>
    <span class="sr-only">Next</span>
  </button>
</div>



<div class="body-content">
    <div class="row">
        
        <div class="col-sm-4">
          <div class="card alturaminima">
            <div class="card-body">
              <h5 class="card-title">La etapa <?=$numero?> con <?=$larga?> kms</h5>
        
              <p class="card-text">La etapa más larga</p>
            </div>
          </div>
        </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title">Maillot más llevado</h5>
                <p class="card-text">Código del maillo + número de veces que se ha llevado</p>
              </div>
            </div>
         </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title">Hay <?=$circular?> etapas circulares</h5>
                <p class="card-text">Número de etapas circulares.</p>
              </div>
            </div>
          </div>
        
    </div>
    
    <div class="row">
        <div class="col-sm-4">
          <div class="card alturaminima">
            <div class="card-body">
              <h5 class="card-title">Ciclista que ha ganado más etapas</h5>
              <p class="card-text">Nombre del ciclista + número de etapas ganadas..</p>
            </div>
          </div>
        </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title">Ciclista que ha ganado más puerto</h5>
                <p class="card-text">Nombre del ciclista + número de puertos ganados.</p>
              </div>
            </div>
         </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title">Ciclista que ha llevado más maillots</h5>
                <p class="card-text">Nombre del ciclista + número de maillots llevados.</p>
              </div>
            </div>
          </div>
        
    </div>
    
    <div class="row">
        <div class="col-sm-4">
          <div class="card alturaminima">
            <div class="card-body">
              <h5 class="card-title"><?=$masalto?> con <?=$altura?> m</h5>
              <p class="card-text">Puerto más alto</p>
            </div>
          </div>
        </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title">Equipo con el mayor número de ciclistas</h5>
                <p class="card-text">Nombre del equipo + número de ciclista</p>
              </div>
            </div>
         </div>
        
        <div class="col-sm-4">
            <div class="card alturaminima">
              <div class="card-body">
                <h5 class="card-title"><?=$media?> años</h5>
                <p class="card-text">Edad media de los ciclistas</p>
              </div>
            </div>
          </div>
        
    </div>
        
</div>
 
 

views/site/index.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
$this->title = 'My Yii Application';
?>
<div id="fondo">
    
    <h1>Vuelta Ciclista España</h1>
    
    <p> <?= Html::a('Estadísticas Generales',['site/generales'], ['class' => 'btn btn-info btn-lg btn-block'] ) ?></p>
    <p> <?= Html::a('Estadísticas De los Ciclistas',['site/ciclistas'], ['class' => 'btn btn-info btn-lg btn-block'] ) ?></p>

</div>

views/site/login.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\LoginForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
$titulo = 'Vuelta España';
?>


<div class="jumbotron">
    <?=   ListView::widget([
            'dataProvider' => $resultados,
           'itemView' => '_resultado',
          'layout'=>"{items}",
          'viewParams' => ['totales' => $totales, 'puertos'=>$puertos, 'maillots'=>$maillots, 'premio'=>"$premio"],

        ]);
?>
    
  
    </div>